// KEKS/CM -- KEKS-encoded cryptographic messages
// Copyright (C) 2024-2025 Sergey Matveev <stargrave@stargrave.org>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation, version 3 of the License.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this program.  If not, see <http://www.gnu.org/licenses/>.

package merkle

import "hash"

// Create Merkle-tree hasher as suggested in RFC 9162 that uses 0x00 and
// 0x01 prefixes for leaf/node separation.
func NewHasherPrefixed(h func() hash.Hash, chunkLen, workers int) *Hasher {
	return NewHasher(
		h,
		h,
		func(h hash.Hash) hash.Hash {
			h.Reset()
			if _, err := h.Write([]byte{0x00}); err != nil {
				panic(err)
			}
			return h
		},
		func(h hash.Hash) hash.Hash {
			h.Reset()
			if _, err := h.Write([]byte{0x01}); err != nil {
				panic(err)
			}
			return h
		},
		chunkLen,
		workers,
	)
}
